/* << High C V1.4 >> **********************************************************
**
**	CDtײؗp CD-ROMԌvZ۸
**
**	1991.02.09 : CREATE
**	1991.02.09 : FINISH
**
**	< HISTORY >
**	1991.02.09 : CREATE
**	1991.02.27 : SʉJn....
**	1991.03.23 : SʉI(Vײؒa)
**	1991.03.28 : programްǉިo/ިc莞Ԃ޸ޏC.
**	1991.03.30 : CDDA_next_music() ɂčŌ̋Ȃ̎̏ŁA۸Ӱޗp
**			     cȐ̐ݒɌ肪̂C.
**	1991.06.07 : 
**
**	< note > : TABS = 4
**
**	All Rights Reserved, Copyright (C) Y.Hirata 1991.
**
**	Programmed by Y.Hirata ( Nifty ID : NAB03321 )
**
******************************************************************************/

#undef _CDDA_LIB

#include <string.h>
#include <stdlib.h>
#include "cdda.h"

extern char	CDDA_FLG_pauseplay ;	/*  tJnw莞ԂPAUSE邩H	*/

extern int	CDDA_PLAY_no[CDDA_MAX_TRACK] ;	/*  tpȔԍi[			*/
extern int	CDDA_nplay ;					/*  ́̓ԖڂH		*/
extern int	CDDA_prgptr ;					/*  ۸їp߲				*/

extern int	CDDA_PLAY_mode ;				/*  ݂̉tӰ				*/

/**************************  Ԃ̑召߂  *****************************/
int	CDDA_cmptime(
		signed char min1,signed char sec1,signed char frame1,
		signed char min2,signed char sec2,signed char frame2 )
/*=============================================================================
**	2CDpԂr.
**
**	< INPUT  > : r2̎(bڰ)
**	< OUTPUT > : Ȃ
**	< RETURN > : 召֌W( T1 < T2  -1 , T1 = T2  0 , T1 > T2  +1 )
**
**	Ԃ̐͂ĂȂ̂ŁAsްgpȂ悤ɂĉ.
=============================================================================*/
{
	if ( min1 > min2 ) {
		return( 1 ) ;									/*  TIME1 > TIME2	*/

	} else if ( min1 == min2 ) {
		if ( sec1 > sec2 ) {
			return( 1 ) ;								/*  TIME1 > TIME2	*/

		} else if ( sec1 == sec2 ) {
			if ( frame1 > frame2 ) {
				return( 1 ) ;							/*  TIME1 > TIME2	*/

			} else if ( frame1 == frame2 ) {
				return( 0 ) ;							/*  TIME1 = TIME2	*/

			} else {
				return( -1 ) ;							/*  TIME1 < TIME2	*/
			}

		} else {
			return( -1 ) ;								/*  TIME1 < TIME2	*/
		}

	} else {
		return( -1 ) ;									/*  TIME1 < TIME2	*/
	}
}

/****************************  ԍ߂  *******************************/
void CDDA_subtime(
		char min1,char sec1,char frame1,
		char min2,char sec2,char frame2,
		char *min,char *sec,char *frame )
/*=============================================================================
**	2CDpԂ̍߂.
**
**	< INPUT  > : 1, 2 (bڰ)
**	< OUTPUT > : 3 = 1 - 2 (bڰ)
**	< RETURN > : Ȃ
**
**	K 1 >= 2 Ƃĉ.
**	Ԃ̐͂ĂȂ̂ŁAsްgpȂ悤ɂĉ.
=============================================================================*/
{
	*min = 0 ; *sec = 0 ; *frame = 0 ;
	if ( frame1 >= frame2 ) {
		*frame = frame1 - frame2 ;
	} else {
		frame1 += 75 ;
		if ( sec1 == 0 ) {
			sec1 += 60 ;
			min1 -- ;
		}
		sec1 -- ;
		*frame = frame1 - frame2 ;
	}
	if ( sec1 >= sec2 ) {
		*sec = sec1 - sec2 ;
	} else {
		sec1 += 60 ;
		min1 -- ;
		*sec = sec1 - sec2 ;
	}
	*min = min1 - min2 ;

}

/****************************  Ԙa߂  *******************************/
void CDDA_addtime(
		char min1,char sec1,char frame1,
		char min2,char sec2,char frame2,
		char *min,char *sec,char *frame )
/*=============================================================================
**	2CDpԂ̘a߂.
**
**	< INPUT  > : 1, 2 (bڰ)
**	< OUTPUT > : 3 = 1 + 2 (bڰ)
**	< RETURN > : Ȃ
**
**	Ԃ̐͂ĂȂ̂ŁAsްgpȂ悤ɂĉ.
=============================================================================*/
{
	min1 += min2 ;
	sec1 += sec2 ;
	frame1 += frame2 ;
	if ( sec1 >= 60 ) {
		sec1 -= 60 ;
		min1 ++ ;
	}
	if ( frame1 >= 75 ) {
		frame1 -= 75 ;
		sec1 ++ ;
		if ( sec1 >= 60 ) {
			sec1 -= 60 ;
			min1 ++ ;
		}
	}
	*min = min1 ;
	*sec = sec1 ;
	*frame = frame1 ;
}

/***************************  tJnԂ̐ݒ  ****************************/
void CDDA_set_time_start( int trackno )
/*=============================================================================
**	tp̊JnԂݒ肷.
**
**	< INPUT  > : tJnׯ(Ȕԍ:1`99)
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	sȋȔԍw肳ꂽꍇɂ́AIɋȔԍύX܂.
=============================================================================*/
{
	int		c ;

	if ( trackno < CDDA_INFO_buf.start ) trackno = CDDA_INFO_buf.start ;
	if ( trackno > CDDA_INFO_buf.end )   trackno = CDDA_INFO_buf.end ;

	if ( CDDA_data_check( trackno ) ) {					/*  ް		*/
		for ( c=trackno+1; c<CDDA_INFO_buf.end; c++ ) {
			trackno ++ ;
			if ( !CDDA_data_check( trackno ) ) {		/*  			*/
				break ;
			}
		}
		if ( c == CDDA_INFO_buf.end ) trackno = CDDA_INFO_buf.end ;
	}

	CDDA_NOW_start = trackno ;

	CDDA_CLOCK_start.sec   = CDDA_INFO_buf.track[trackno-1].sec ;
	CDDA_CLOCK_start.min   = CDDA_INFO_buf.track[trackno-1].min ;
	CDDA_CLOCK_start.frame = CDDA_INFO_buf.track[trackno-1].frame ;
}

/*************************  tIԂ̐ݒ  ******************************/
void CDDA_set_time_end( int trackno )
/*=============================================================================
**	tp̏IԂݒ肷.
**
**	< INPUT  > : tIׯ(Ȕԍ)
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	sȋȔԍw肳ꂽꍇɂ́AIɋȔԍύX܂.
=============================================================================*/
{
	char	minw, secw, framew ;
	int		c ;

/*	frame : 0 - 74 : 75frame=1sec	*/

	if ( trackno < CDDA_INFO_buf.start ) trackno = CDDA_INFO_buf.start ;
	if ( trackno < CDDA_INFO_buf.end ) {
		if ( CDDA_data_check( trackno+1 ) ) {				/*  ް		*/
			trackno ++ ;
			for ( c=trackno+1; c<CDDA_INFO_buf.end; c++ ) {
				trackno ++ ;
				if ( !CDDA_data_check( trackno ) ) {		/*  			*/
					break ;
				}
			}
			if ( c >= CDDA_INFO_buf.end ) trackno = CDDA_INFO_buf.end ;
		}
	} else {
		trackno = CDDA_INFO_buf.end ;
	}
/*
**	Ō̋Ȃ܂(܂͍Ō̋Ȃ)t`ɂ́A
**	tIԂ̎wɒӂ܂傤I
**
**	 tIԂ́AfBXNtIԂ 1 t[lw
**	   ȂƂ߂I
*/
	if ( trackno >= CDDA_INFO_buf.end ) {	/*  ŏIȂw肳ꂽ	*/
		trackno = CDDA_INFO_buf.end ;
		framew = CDDA_INFO_buf.discend.frame ;
		secw   = CDDA_INFO_buf.discend.sec ;
		minw   = CDDA_INFO_buf.discend.min ;
	} else {									/*  ŏIȂȂ		*/
		framew = CDDA_INFO_buf.track[trackno].frame ;
		secw   = CDDA_INFO_buf.track[trackno].sec ;
		minw   = CDDA_INFO_buf.track[trackno].min ;
	}
															/*  1ڰш	*/
	CDDA_subtime( minw,secw,framew,0,0,1,&minw,&secw,&framew ) ;

	CDDA_NOW_end = trackno ;

	CDDA_CLOCK_end.frame = framew ;
	CDDA_CLOCK_end.sec = secw ;
	CDDA_CLOCK_end.min = minw ;
}

/****************************  eȂ̎Ԃ߂  ***************************/
void CDDA_timecalc( void )
/*=============================================================================
**	eȂ̉t, y̍v, ް̍vԂ߂.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	K TOC擾ɂ̊֐CALLĉ.
=============================================================================*/
{
	int		c ;
	char	minw, min2, sec2, frame2 ;

/*	ԏޯĂON̏ꍇɂ́AȂł͂ȂްłB	*/

	CDDA_TIME_music.min = CDDA_TIME_music.sec = CDDA_TIME_music.frame = 0 ;
	CDDA_TIME_data.min = CDDA_TIME_data.sec = CDDA_TIME_data.frame = 0 ;

	for ( c=0; c<CDDA_INFO_buf.end; c++ ) {

		minw = CDDA_INFO_buf.track[c].min ;
		if ( ( minw & 0x80 ) == 0x80 ) minw &= 0x7f ;

		if ( c+1 < CDDA_INFO_buf.end ) {			/*  ̋ȂŏIؑO	*/
			frame2 = CDDA_INFO_buf.track[c+1].frame ;
			sec2 = CDDA_INFO_buf.track[c+1].sec ;
			min2 = CDDA_INFO_buf.track[c+1].min ;
			if ( ( min2 & 0x80 ) == 0x80 ) min2 &= 0x7f ;
		} else {									/*  ̋ȂŏI		*/
			frame2 = CDDA_INFO_buf.discend.frame ;
			sec2 = CDDA_INFO_buf.discend.sec ;
			min2 = CDDA_INFO_buf.discend.min ;
			if ( ( min2 & 0x80 ) == 0x80 ) min2 &= 0x7f ;
			CDDA_subtime( min2,sec2,frame2,0,0,1,&min2,&sec2,&frame2 ) ;
															/*  1ڰш	*/
		}
		CDDA_subtime( min2,sec2,frame2,minw,
				CDDA_INFO_buf.track[c].sec,CDDA_INFO_buf.track[c].frame,
				&CDDA_TIME_track[c].min,&CDDA_TIME_track[c].sec,
				&CDDA_TIME_track[c].frame ) ;
														/*  ȎԎ擾		*/
		minw = CDDA_INFO_buf.track[c].min ;
		if ( ( minw & 0x80 ) != 0x80 ) {				/*  CD-DA Z	*/
			CDDA_addtime( CDDA_TIME_music.min,CDDA_TIME_music.sec,
					CDDA_TIME_music.frame,
					CDDA_TIME_track[c].min,CDDA_TIME_track[c].sec,
					CDDA_TIME_track[c].frame,
					&CDDA_TIME_music.min,&CDDA_TIME_music.sec,
					&CDDA_TIME_music.frame ) ;
														/*  vԎ擾	*/
		} else {										/*  ް̍v	*/
			CDDA_addtime( CDDA_TIME_data.min,CDDA_TIME_data.sec,
					CDDA_TIME_data.frame,
					CDDA_TIME_track[c].min,CDDA_TIME_track[c].sec,
					CDDA_TIME_track[c].frame,
					&CDDA_TIME_data.min,&CDDA_TIME_data.sec,
					&CDDA_TIME_data.frame ) ;
														/*  vԎ擾	*/
		}
	}
/*
**	۸юԸر
*/
	CDDA_TIME_program.min   = CDDA_ZERO ;
	CDDA_TIME_program.sec   = CDDA_ZERO ;
	CDDA_TIME_program.frame = CDDA_ZERO ;
}

/**************************  ݂̎c莞Ԃ߂  *************************/
void CDDA_remaintime( void )
/*=============================================================================
**	t(ȓ,ި)߂.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	tԎ擾ɂ̊֐CALLĉ.
**	(CDDA_status()ŁÅ֐CALLĂ܂)
=============================================================================*/
{
	int		c ;

/*
**	ȔԍsȎ(t\ȂłȂ)
*/
	if ( CDDA_INFO_buf.start > CDDA_NOW_musicno ||
			CDDA_NOW_musicno > CDDA_INFO_buf.end ||
			CDDA_data_check( CDDA_NOW_musicno ) ||
			CDDA_NOW_musicno <= CDDA_ZERO ) {
		CDDA_CLOCK_nowtrack.min   = CDDA_ZERO ;
		CDDA_CLOCK_nowtrack.sec   = CDDA_ZERO ;
		CDDA_CLOCK_nowtrack.frame = CDDA_ZERO ;
		memcpy( (char *)&CDDA_TIME_nowtrack,(char *)&CDDA_CLOCK_nowtrack,
				sizeof( CDDA_TRACK ) ) ;
		memcpy( (char *)&CDDA_CLOCK_nowdisc,(char *)&CDDA_CLOCK_nowtrack,
				sizeof( CDDA_TRACK ) ) ;
		memcpy( (char *)&CDDA_TIME_nowdisc,(char *)&CDDA_CLOCK_nowtrack,
				sizeof( CDDA_TRACK ) ) ;
		return ;
	}

/*
**	݂̋Ȃ̎c莞
*/
	CDDA_subtime( CDDA_TIME_track[CDDA_NOW_musicno-1].min,
			CDDA_TIME_track[CDDA_NOW_musicno-1].sec,
			CDDA_TIME_track[CDDA_NOW_musicno-1].frame,
			CDDA_CLOCK_nowtrack.min,
			CDDA_CLOCK_nowtrack.sec,
			CDDA_CLOCK_nowtrack.frame,
			&CDDA_TIME_nowtrack.min,
			&CDDA_TIME_nowtrack.sec,
			&CDDA_TIME_nowtrack.frame ) ;
	memcpy( (char *)&CDDA_TIME_nowdisc,(char *)&CDDA_TIME_nowtrack,
			sizeof( CDDA_TRACK ) ) ;

/*
**	İق̎c莞
*/
	switch ( CDDA_PLAY_mode ) {
	case CDDA_SW_SHUFFLE :
	case CDDA_SW_PROGRAM :
	case CDDA_SW_CONTINUE :
		for ( c=0; c<CDDA_MAX_TRACK; c++ ) {
			if ( CDDA_nplay+c >= CDDA_MAX_TRACK ) break ;
			if ( CDDA_PLAY_no[CDDA_nplay+c] <= CDDA_ZERO ) break ;
			if ( !CDDA_data_check(CDDA_PLAY_no[CDDA_nplay+c]) ) {
				/*  yȂ...	*/
				CDDA_addtime( CDDA_TIME_nowdisc.min,
					CDDA_TIME_nowdisc.sec,
					CDDA_TIME_nowdisc.frame,
					CDDA_TIME_track[CDDA_PLAY_no[CDDA_nplay+c]-1].min,
					CDDA_TIME_track[CDDA_PLAY_no[CDDA_nplay+c]-1].sec,
					CDDA_TIME_track[CDDA_PLAY_no[CDDA_nplay+c]-1].frame,
					&CDDA_TIME_nowdisc.min,
					&CDDA_TIME_nowdisc.sec,
					&CDDA_TIME_nowdisc.frame ) ;
			}
		}
		break ;
	case CDDA_SW_SINGLE :
		break ;
	}

/*
**	İق̌oߎ
*/
	switch ( CDDA_PLAY_mode ) {
	case CDDA_SW_SHUFFLE :
	case CDDA_SW_CONTINUE :
		CDDA_subtime( CDDA_TIME_music.min,
					CDDA_TIME_music.sec,
					CDDA_TIME_music.frame,
					CDDA_TIME_nowdisc.min,
					CDDA_TIME_nowdisc.sec,
					CDDA_TIME_nowdisc.frame,
					&CDDA_CLOCK_nowdisc.min,
					&CDDA_CLOCK_nowdisc.sec,
					&CDDA_CLOCK_nowdisc.frame ) ;
		break ;
	case CDDA_SW_PROGRAM :
		CDDA_subtime( CDDA_TIME_program.min,
					CDDA_TIME_program.sec,
					CDDA_TIME_program.frame,
					CDDA_TIME_nowdisc.min,
					CDDA_TIME_nowdisc.sec,
					CDDA_TIME_nowdisc.frame,
					&CDDA_CLOCK_nowdisc.min,
					&CDDA_CLOCK_nowdisc.sec,
					&CDDA_CLOCK_nowdisc.frame ) ;
		break ;
	case CDDA_SW_SINGLE :
		memcpy( (char *)&CDDA_CLOCK_nowdisc,(char *)&CDDA_CLOCK_nowtrack,
				sizeof( CDDA_TRACK ) ) ;
		break ;
	}
}

/*********************  ۸ъ֌W݂̌̎c莞Ԃ߂  *****************/
void CDDA_program_remaintime( void )
/*=============================================================================
**	۸ъ֌W̉t(ȓ,ި)߂.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	۸Ӱނ̎ɋȔԍ̒ǉ/mFpɂ̊֐gp܂.
**	۸эv(CDDA_TIME_PROGRAM), ȓoߎ(CDDA_CLOCK_nowtrack)́A
**	ĂяoOɐݒ肵Ăĉ.
=============================================================================*/
{
	int		c, sp ;

	if ( CDDA_PLAY_mode != CDDA_SW_PROGRAM ) return ;

/*
**	݂̋ȓc莞
*/
	if ( CDDA_NOW_musicno > CDDA_ZERO ) {
		CDDA_subtime( CDDA_TIME_track[CDDA_NOW_musicno-1].min,
				CDDA_TIME_track[CDDA_NOW_musicno-1].sec,
				CDDA_TIME_track[CDDA_NOW_musicno-1].frame,
				CDDA_CLOCK_nowtrack.min,
				CDDA_CLOCK_nowtrack.sec,
				CDDA_CLOCK_nowtrack.frame,
				&CDDA_TIME_nowtrack.min,
				&CDDA_TIME_nowtrack.sec,
				&CDDA_TIME_nowtrack.frame ) ;
	} else {
		CDDA_TIME_nowtrack.min   = CDDA_ZERO ;
		CDDA_TIME_nowtrack.sec   = CDDA_ZERO ;
		CDDA_TIME_nowtrack.frame = CDDA_ZERO ;
	}

/*
**	İق̎c莞
*/
	memcpy( (char *)&CDDA_TIME_nowdisc,(char *)&CDDA_TIME_nowtrack,
			sizeof( CDDA_TRACK ) ) ;
	for ( c=0; c<CDDA_MAX_TRACK; c++ ) {
		if ( CDDA_prgptr+c >= CDDA_MAX_TRACK ) break ;
		if ( CDDA_PLAY_no[CDDA_prgptr+c] <= CDDA_ZERO ) break ;
		if ( !CDDA_data_check(CDDA_PLAY_no[CDDA_prgptr+c]) ) {
			/*  yȂ...	*/
			CDDA_addtime( CDDA_TIME_nowdisc.min,
				CDDA_TIME_nowdisc.sec,
				CDDA_TIME_nowdisc.frame,
				CDDA_TIME_track[CDDA_PLAY_no[CDDA_prgptr+c]-1].min,
				CDDA_TIME_track[CDDA_PLAY_no[CDDA_prgptr+c]-1].sec,
				CDDA_TIME_track[CDDA_PLAY_no[CDDA_prgptr+c]-1].frame,
				&CDDA_TIME_nowdisc.min,
				&CDDA_TIME_nowdisc.sec,
				&CDDA_TIME_nowdisc.frame ) ;
		}
	}
	if ( CDDA_prgptr == CDDA_ZERO ) {
		CDDA_subtime( CDDA_TIME_nowdisc.min,
					CDDA_TIME_nowdisc.sec,
					CDDA_TIME_nowdisc.frame,
					CDDA_TIME_nowtrack.min,
					CDDA_TIME_nowtrack.sec,
					CDDA_TIME_nowtrack.frame,
					&CDDA_TIME_nowdisc.min,
					&CDDA_TIME_nowdisc.sec,
					&CDDA_TIME_nowdisc.frame ) ;
	}

/*
**	İٌoߎ
*/
	CDDA_subtime( CDDA_TIME_program.min,
				CDDA_TIME_program.sec,
				CDDA_TIME_program.frame,
				CDDA_TIME_nowdisc.min,
				CDDA_TIME_nowdisc.sec,
				CDDA_TIME_nowdisc.frame,
				&CDDA_CLOCK_nowdisc.min,
				&CDDA_CLOCK_nowdisc.sec,
				&CDDA_CLOCK_nowdisc.frame ) ;

/*
**	۸ьoߎ(t(t)wꂽȔԍ܂ł̍v)
*/
	CDDA_CLOCK_program.min   = CDDA_ZERO ;
	CDDA_CLOCK_program.sec   = CDDA_ZERO ;
	CDDA_CLOCK_program.frame = CDDA_ZERO ;
	sp = CDDA_ZERO ;
	if ( CDDA_nplay > CDDA_ZERO ) sp = CDDA_nplay - 1 ;
	for ( c=sp; c<CDDA_MAX_TRACK; c++ ) {
		if ( CDDA_PLAY_no[c] == CDDA_ZERO ) break ;
		if ( CDDA_prgptr && c == CDDA_prgptr ) break ;
		CDDA_addtime( CDDA_CLOCK_program.min,
				CDDA_CLOCK_program.sec,
				CDDA_CLOCK_program.frame,
				CDDA_TIME_track[CDDA_PLAY_no[c]-1].min,
				CDDA_TIME_track[CDDA_PLAY_no[c]-1].sec,
				CDDA_TIME_track[CDDA_PLAY_no[c]-1].frame,
				&CDDA_CLOCK_program.min,
				&CDDA_CLOCK_program.sec,
				&CDDA_CLOCK_program.frame ) ;
	}
}

/***************************  ްǂ  **************************/
int CDDA_data_check( int musicno )
/*=============================================================================
**	w肳ꂽȔԍްǂ.
**
**	< INPUT  > : Ȕԍ
**	< OUTPUT > : Ȃ
**	< RETURN > : ް Ȃ ^l , y Ȃ Ul.
**
**	sȋȔԍw肵Ȃŉ.
=============================================================================*/
{
	if ( musicno <= CDDA_ZERO ) return( CDDA_FALSE ) ;
	return( ( ( CDDA_INFO_buf.track[musicno-1].min & 0x80 ) == 0x80 ) ?
		CDDA_TRUE : CDDA_FALSE ) ;
}

/*******************************  ̋Ȃݒ  ******************************/
int CDDA_next_music( void )
/*=============================================================================
**	ɉtȔԍݒ肷.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : װl(tȂȂȂꍇɂʹװԂ)
=============================================================================*/
{
	char	endflg ;
	int		c ;

/*
**	̋Ȕԍݒ
*/
	endflg = CDDA_FALSE ;
	for ( c=CDDA_nplay; c<=CDDA_MAX_TRACK; c++ ) {
		if ( CDDA_PLAY_no[c] == CDDA_ZERO ) {
			endflg = CDDA_TRUE ;
			break ;
		}
		CDDA_nplay ++ ;
		if ( CDDA_nplay > CDDA_MAX_TRACK ) {
			CDDA_nplay = CDDA_MAX_TRACK ;
			endflg = CDDA_TRUE ;
			break ;
		}
		if ( !CDDA_data_check(CDDA_PLAY_no[CDDA_nplay-1]) ) {
			/*  yȂ...	*/
			CDDA_NOW_start = CDDA_PLAY_no[CDDA_nplay-1] ;	/*  tȔԍ	*/
			break ;
		}
	}
	if ( endflg ) {
		CDDA_NOW_end = CDDA_NOW_start ;
	} else {
		switch ( CDDA_PLAY_mode ) {
		case CDDA_SW_SHUFFLE :
		case CDDA_SW_PROGRAM :
		case CDDA_SW_SINGLE :
			CDDA_NOW_end = CDDA_NOW_start ;
			break ;
		case CDDA_SW_CONTINUE :
			CDDA_NOW_end = CDDA_INFO_buf.end ;
			break ;
		}
	}

	if ( CDDA_PLAY_mode == CDDA_SW_PROGRAM ) {
		CDDA_prgptr = CDDA_ZERO ;
		if ( endflg ) {
			if ( CDDA_nplay > CDDA_ZERO ) {
				if ( CDDA_PLAY_no[CDDA_nplay-1] == CDDA_ZERO ) {
					CDDA_REMAIN_program = CDDA_ZERO ;
				}
			} else {
				CDDA_REMAIN_program = CDDA_ZERO ;
			}
		} else {
			CDDA_REMAIN_program -- ;
		}
	}

/*
**	return
*/
	return( endflg ? CDDA_ERR_PARAMETER : CDDA_ERR_NOERROR ) ;
}

/*******************************  ŐȂݒ  ******************************/
int CDDA_before_music( void )
/*=============================================================================
**	ȑOɉtȔԍݒ肷.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : װl(tȂ擪OɂȂꍇɂʹװԂ)
=============================================================================*/
{
	int		cmp ;
	char	endflg ;
	int		c ;

/*
**	Ȕԍ
*/
	endflg = CDDA_FALSE ;
	cmp = CDDA_cmptime(	(signed char)CDDA_CLOCK_nowtrack.min,
						(signed char)CDDA_CLOCK_nowtrack.sec,
						(signed char)CDDA_CLOCK_nowtrack.frame,
						0,2,0 ) ;
	if ( CDDA_NOW_start == CDDA_PLAY_no[0] && cmp <= CDDA_ZERO )
		endflg = CDDA_TRUE ;
	if ( CDDA_PLAY_no[0] == CDDA_ZERO ) endflg = CDDA_TRUE ;
/*-----------------------------------------------------------------------------
**	Ӱ, ۸Ӱގɂ́AŐȂɖ߂邱Ƃ͂Ȃ.
-----------------------------------------------------------------------------*/
	switch ( CDDA_PLAY_mode ) {
	case CDDA_SW_SHUFFLE :
	case CDDA_SW_PROGRAM :
		endflg = CDDA_TRUE ;
	}

/*
**	ŐȔԍݒ
*/
	if ( cmp <= CDDA_ZERO && !endflg ) {
		for ( c=CDDA_nplay; c>=CDDA_ZERO; c-- ) {
			CDDA_nplay -- ;
			if ( CDDA_nplay <= CDDA_ZERO ) {
				CDDA_nplay = CDDA_ZERO ;
				endflg = CDDA_TRUE ;
				break ;
			}
			if ( CDDA_PLAY_no[CDDA_nplay-1] == CDDA_ZERO ) {
				endflg = CDDA_TRUE ;
				break ;
			}
			if ( !CDDA_data_check(CDDA_PLAY_no[CDDA_nplay-1]) ) {
				/*  yȂ...	*/
				CDDA_NOW_start = CDDA_PLAY_no[CDDA_nplay-1] ;/*  tȔԍ	*/
				break ;
			}
		}
		if ( !endflg ) {
			switch ( CDDA_PLAY_mode ) {
			case CDDA_SW_SHUFFLE :
			case CDDA_SW_PROGRAM :
			case CDDA_SW_SINGLE :
				CDDA_NOW_end = CDDA_NOW_start ;
				break ;
			case CDDA_SW_CONTINUE :
				CDDA_NOW_end = CDDA_INFO_buf.end ;
				break ;
			}
		}
	}

	if ( CDDA_PLAY_mode == CDDA_SW_PROGRAM ) {
		CDDA_prgptr = CDDA_ZERO ;
	}

/*
**	return
*/
	return( endflg ? CDDA_ERR_PARAMETER : CDDA_ERR_NOERROR ) ;
}

/******************************  CD 摗菈  ******************************/
int CDDA_fftime( void )
/*=============================================================================
**	tԂ摗肷.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : װl(tԂŌɓBꍇɂʹװԂ)
**
**	̊֐́Aꎞ~CALLĉ.
=============================================================================*/
{
	char	nmin, nsec, nframe ;				/*  tԕ\p			*/
	int		cmp ;
	char	endflg ;

	if ( CDDA_NOW_status == CDDA_STAT_PAUSE ) {	/*  PAUSE					*/
		if ( CDDA_NOW_musicno < 1 ) return( CDDA_ERR_PARAMETER ) ;
		CDDA_NOW_start = CDDA_NOW_musicno ;
		CDDA_FLG_pauseplay = CDDA_TRUE ;
		nsec   = CDDA_CLOCK_nowtrack.sec ;
		nmin   = CDDA_CLOCK_nowtrack.min ;
		nframe = CDDA_ZERO ;
	} else {									/*  PAUSEłȂ			*/
		return( CDDA_ERR_NOTPAUSE ) ;
	}

	endflg = CDDA_FALSE ;

/*
**	Ԃ𑗂
*/
	CDDA_addtime( nmin,nsec,nframe,0,CDDA_FFREV_SEC,0,&nmin,&nsec,&nframe ) ;

/*
**	Ԃ
*/
	cmp = CDDA_cmptime( (signed char)nmin,(signed char)nsec,0,
				(signed char)CDDA_TIME_track[CDDA_NOW_start-1].min,
				(signed char)CDDA_TIME_track[CDDA_NOW_start-1].sec,0 ) ;

	if ( cmp > 0 ) {								/*  ̋ȎԂɓ˓	*/
/*
**	̋Ȕԍݒ
*/
		if ( CDDA_next_music() ) endflg = CDDA_TRUE ;
		nmin = nsec = nframe = CDDA_ZERO ;
	}

	CDDA_NOW_pause = CDDA_NOW_musicno = CDDA_NOW_start ;

/*
**	tԂ̎w
*/
	if ( endflg ) {								/*  I				*/
		CDDA_set_time_end( CDDA_NOW_end ) ;		/*  tIȃf[^ݒ	*/
		memcpy( (char *)&CDDA_CLOCK_start,(char *)&CDDA_CLOCK_end,
				sizeof( CDDA_TRACK ) ) ;
		nmin   = CDDA_TIME_track[CDDA_NOW_end-1].min ;
		nsec   = CDDA_TIME_track[CDDA_NOW_end-1].sec ;
		nframe = CDDA_TIME_track[CDDA_NOW_end-1].frame ;
	} else {
		CDDA_set_time_start( CDDA_NOW_start ) ;	/*  tJnȃf[^ݒ	*/
		CDDA_addtime( CDDA_CLOCK_start.min,
				CDDA_CLOCK_start.sec,
				CDDA_CLOCK_start.frame,
				nmin,nsec,0,
				&CDDA_CLOCK_start.min,
				&CDDA_CLOCK_start.sec,
				&CDDA_CLOCK_start.frame ) ;
		CDDA_set_time_end( CDDA_NOW_end ) ;		/*  tIȃf[^ݒ	*/
		if ( cmp > 0 ) CDDA_seek() ;
	}

/*
**	݂̋ȓoߎ
*/
	CDDA_CLOCK_nowtrack.min   = nmin ;
	CDDA_CLOCK_nowtrack.sec   = nsec ;
	CDDA_CLOCK_nowtrack.frame = nframe ;
	memcpy( (char *)&CDDA_CLOCK_pause,(char *)&CDDA_CLOCK_nowtrack,
			sizeof( CDDA_TRACK ) ) ;

/*
**	݂̎c莞
*/
	CDDA_remaintime() ;

/*
**	return
*/
	return( endflg ? CDDA_ERR_PARAMETER : CDDA_ERR_NOERROR ) ;
}

/******************************  CD ߂菈  ******************************/
int CDDA_rewtime( void )
/*=============================================================================
**	tԂ߂肷.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : װl(tԂ擪ɓBꍇɂʹװԂ)
**
**	̊֐́Aꎞ~CALLĉ.
=============================================================================*/
{
	char	nmin, nsec, nframe ;					/*  tԕ\p		*/
	int		cmp ;
	char	endflg ;

	if ( CDDA_NOW_status == CDDA_STAT_PAUSE ) {		/*  PAUSE				*/
		if ( CDDA_NOW_musicno < 1 ) return( CDDA_ERR_PARAMETER ) ;
		CDDA_NOW_start = CDDA_NOW_musicno ;
		CDDA_FLG_pauseplay = CDDA_TRUE ;
		nsec   = CDDA_CLOCK_nowtrack.sec ;
		nmin   = CDDA_CLOCK_nowtrack.min ;
		nframe = CDDA_ZERO ;
	} else {										/*  PAUSEłȂ		*/
		return( CDDA_ERR_NOTPAUSE ) ;
	}

	endflg = CDDA_FALSE ;

/*
**	Ԃ߂
*/
	CDDA_subtime( nmin,nsec,nframe,0,CDDA_FFREV_SEC,0,&nmin,&nsec,&nframe ) ;

/*
**	Ԃ
*/
	cmp = CDDA_cmptime( (signed char)nmin,(signed char)nsec,0,0,0,0 ) ;

	if ( cmp < 0 ) {								/*  ŐȎԂɓ˓	*/
/*
**	ŐȔԍݒ
*/
		if ( CDDA_before_music() ) endflg = CDDA_TRUE ;
		if ( endflg ) {
			nmin = nsec = nframe = CDDA_ZERO ;
		} else {
			nmin   = CDDA_TIME_track[CDDA_NOW_start-1].min ;
			nsec   = CDDA_TIME_track[CDDA_NOW_start-1].sec ;
			nframe = CDDA_TIME_track[CDDA_NOW_start-1].frame ;
		}
	}

	CDDA_NOW_pause = CDDA_NOW_musicno = CDDA_NOW_start ;

/*
**	tԂ̎w
*/
	CDDA_set_time_start( CDDA_NOW_start ) ;		/*  tJnȃf[^ݒ	*/
	CDDA_addtime( CDDA_CLOCK_start.min,
			CDDA_CLOCK_start.sec,
			CDDA_CLOCK_start.frame,
			nmin,nsec,0,
			&CDDA_CLOCK_start.min,
			&CDDA_CLOCK_start.sec,
			&CDDA_CLOCK_start.frame ) ;
	CDDA_set_time_end( CDDA_NOW_end ) ;			/*  tIȃf[^ݒ	*/
	if ( cmp < 0 ) CDDA_seek() ;

/*
**	݂̋ȓoߎ
*/
	CDDA_CLOCK_nowtrack.min   = nmin ;
	CDDA_CLOCK_nowtrack.sec   = nsec ;
	CDDA_CLOCK_nowtrack.frame = nframe ;
	memcpy( (char *)&CDDA_CLOCK_pause,(char *)&CDDA_CLOCK_nowtrack,
			sizeof( CDDA_TRACK ) ) ;

/*
**	݂̎c莞
*/
	CDDA_remaintime() ;

/*
**	return
*/
	return( endflg ? CDDA_ERR_PARAMETER : CDDA_ERR_NOERROR ) ;
}

/****************************  CD ȓo  ****************************/
int CDDA_ffmusic( void )
/*=============================================================================
**	tȂ摗肷.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : װl(tȂȂȂꍇɂʹװԂ)
**
**	̊֐́Aꎞ~CALLĉ.
=============================================================================*/
{
	char	endflg ;

/*
**	tԂ
*/
	if ( CDDA_NOW_status == CDDA_STAT_PAUSE ) {	/*  PAUSE					*/
		CDDA_FLG_pauseplay = CDDA_TRUE ;
	} else {									/*  PAUSEłȂ			*/
		return( CDDA_ERR_NOTPAUSE ) ;
	}

/*
**	̋Ȕԍݒ
*/
	endflg = CDDA_FALSE ;
	if ( CDDA_next_music() ) endflg = CDDA_TRUE ;

	CDDA_NOW_pause = CDDA_NOW_musicno = CDDA_NOW_start ;

/*
**	tԂ̎w
*/
	CDDA_set_time_start( CDDA_NOW_start ) ;		/*  tJnȃf[^ݒ	*/
	CDDA_set_time_end( CDDA_NOW_end ) ;			/*  tIȃf[^ݒ	*/

/*
**	݂̋ȓoߎ
*/
	if ( endflg ) {								/*  I				*/
		memcpy( (char *)&CDDA_CLOCK_start,(char *)&CDDA_CLOCK_end,
				sizeof( CDDA_TRACK ) ) ;
		CDDA_CLOCK_nowtrack.min   = CDDA_TIME_track[CDDA_NOW_end-1].min ;
		CDDA_CLOCK_nowtrack.sec   = CDDA_TIME_track[CDDA_NOW_end-1].sec ;
		CDDA_CLOCK_nowtrack.frame = CDDA_TIME_track[CDDA_NOW_end-1].frame ;
	} else {
		CDDA_CLOCK_nowtrack.min   = CDDA_ZERO ;
		CDDA_CLOCK_nowtrack.sec   = CDDA_ZERO ;
		CDDA_CLOCK_nowtrack.frame = CDDA_ZERO ;
	}
	CDDA_seek() ;
	memcpy( (char *)&CDDA_CLOCK_pause,(char *)&CDDA_CLOCK_nowtrack,
			sizeof( CDDA_TRACK ) ) ;

/*
**	݂̎c莞
*/
	CDDA_remaintime() ;

/*
**	return
*/
	return( endflg ? CDDA_ERR_PARAMETER : CDDA_ERR_NOERROR ) ;
}

/****************************  CD Oȓo  ****************************/
int CDDA_rewmusic( void )
/*=============================================================================
**	tȂ߂肷(t̋Ȃ͓oƂ).
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : װl(tȂ擪OɂȂꍇɂʹװԂ)
**
**	̊֐́Aꎞ~CALLĉ.
=============================================================================*/
{
	char	endflg ;

/*
**	tԂ
*/
	if ( CDDA_NOW_status == CDDA_STAT_PAUSE ) {		/*  PAUSE				*/
		CDDA_FLG_pauseplay = CDDA_TRUE ;
	} else {										/*  PAUSEłȂ		*/
		return( CDDA_ERR_NOTPAUSE ) ;
	}

/*
**	ŐȔԍݒ
*/
	endflg = CDDA_FALSE ;
	if ( CDDA_before_music() ) endflg = CDDA_TRUE ;

	CDDA_NOW_pause = CDDA_NOW_musicno = CDDA_NOW_start ;

/*
**	tԂ̎w
*/
	CDDA_set_time_start( CDDA_NOW_start ) ;		/*  tJnȃf[^ݒ	*/
	CDDA_set_time_end( CDDA_NOW_end ) ;			/*  tIȃf[^ݒ	*/
	CDDA_seek() ;

/*
**	݂̋ȓoߎ
*/
	CDDA_CLOCK_nowtrack.min   = CDDA_ZERO ;
	CDDA_CLOCK_nowtrack.sec   = CDDA_ZERO ;
	CDDA_CLOCK_nowtrack.frame = CDDA_ZERO ;
	memcpy( (char *)&CDDA_CLOCK_pause,(char *)&CDDA_CLOCK_nowtrack,
			sizeof( CDDA_TRACK ) ) ;

/*
**	݂̎c莞
*/
	CDDA_remaintime() ;

/*
**	return
*/
	return( endflg ? CDDA_ERR_PARAMETER : CDDA_ERR_NOERROR ) ;
}

